import { Observer, copy, equal, generateId, RuntimeJob, defineConfig, } from '../../internal';
export class GroupObserver extends Observer {
    constructor(group, config = {}) {
        super(group.agileInstance(), defineConfig(config, { value: group._output }));
        this.group = () => group;
        this.nextGroupOutput = copy(group._output);
    }
    ingest(config = {}) {
        this.group().rebuild(config);
    }
    ingestItems(newGroupItems, config = {}) {
        var _a;
        const group = this.group();
        config = defineConfig(config, {
            perform: true,
            background: false,
            sideEffects: {
                enabled: true,
                exclude: [],
            },
            force: false,
            maxTriesToUpdate: 3,
        });
        if (group.isPlaceholder) {
            config.force = true;
        }
        this.nextGroupOutput = copy(newGroupItems.map((item) => {
            return item._value;
        }));
        if (equal(group._output, this.nextGroupOutput) && !config.force)
            return;
        const job = new RuntimeJob(this, {
            sideEffects: config.sideEffects,
            force: config.force,
            background: config.background,
            key: (_a = config.key) !== null && _a !== void 0 ? _a : `${this._key != null ? this._key + '_' : ''}${generateId()}_output`,
            maxTriesToUpdate: config.maxTriesToUpdate,
        });
        this.agileInstance().runtime.ingest(job, {
            perform: config.perform,
        });
    }
    perform(job) {
        const observer = job.observer;
        const group = observer.group();
        group._output = copy(observer.nextGroupOutput);
        job.observer.previousValue = copy(job.observer.value);
        job.observer.value = copy(group._output);
    }
}
